/*
 * ActivityDiagram.java
 *
 * Created on 22 de abril de 2006, 10:04
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

import java.util.Hashtable;
import java.util.Iterator;

import org.apache.log4j.*;

/**
 *
 * @author Rincew
 */
public class ActivityDiagram {
    
    private Hashtable da;
    private Activity beginNode;
    private Activity finalNode;
    
    
    /** Creates a new instance of ActivityDiagram */
    public ActivityDiagram () {
        this.da = new Hashtable();
        this.beginNode = null;
        
        this.finalNode = Activity.BuildFinal ();
        this.da.put(this.finalNode.getId (), this.finalNode);
        
    }
    
    /** Adds a new activity into de the activity diagram **/
    public void addActivity(Activity a) {
        if (a == null) {
            log.warn ("Adding a null activity.");
        }
        
        this.da.put (a.getId (), a);
        if (this.beginNode == null)
            this.beginNode = a;
    }
    
    /** Adds a transition between two activities 
     *  Before call this method, activities must be inserted 
     * in activity diagram using addActivity methos
     **/
    public void addTransition(Activity org, Activity des) {
        Activity aOrg, aDes;
        
        aOrg = (Activity)this.da.get (org.getId ());
        aDes = (Activity)this.da.get (des.getId ());
        
        if ( (aOrg == null ) || (aDes == null) )
            log.warn("Null activitiies. org:" + aOrg + " / des:" + aDes);
        
        aOrg.setNext (aDes);
            
        
    }
    
    /** Adds a transition between the node an a final node */
    public void finalActivity(Activity a) {
        this.addTransition (a, this.finalNode);
    }
    
    /** Returns first activity
     **/
    public Activity getFirstActivity() {
        return this.beginNode;
    }
    
    

    //--- Iterators ------------------------------------------------------
        
    /** Returns an iterator to traverse all the activities of
     * the activity diagram **/
    public Iterator iteratorActivities() {
        return new ActivitiesIterator(this.da);
    }
    
    
    /** Invalid method **/
    public String toString() {
        
        StringBuffer sb = new StringBuffer("");
        Activity a = this.beginNode;
        
        while(!a.isFinal ()) {
            sb.append (a.toString ());
            a = a.getNext ();
            if (a == null) {
                log.warn ("Activity null. String buffer: " + sb.toString ());
            }
        }
        
        return sb.toString ();
    }
    
    

    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (ActivityDiagram.class.getName());
    }

}

//--- Iterator implementation --------------------------------

class ActivitiesIterator implements Iterator {

    java.util.Enumeration en;
    
    public ActivitiesIterator(Hashtable da) {
        en = da.elements ();
    }
    
    public boolean hasNext () {
        return this.en.hasMoreElements ();
    }

    public Object next () {
        return this.next ();
    }

    /** Not implemented **/
    public void remove () {
        ActivityDiagram.log.fatal ("Remove method is not implemented");
    }

}

