/*
 * ActivityDiagramGenerator.java
 *
 * Created on 22 de abril de 2006, 12:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

import objectgen.usecase.IStep;
import objectgen.usecase.UseCaseXML;

import java.util.Iterator;

import org.apache.log4j.*;

/**
 *
 * @author Rincew
 */
public class ActivityDiagramGenerator {

    
    private Activity lastNodeAdded;
    private ActivityDiagram ad;
    
    
    /** Creates a new instance of ActivityDiagramGenerator */
    public ActivityDiagramGenerator () {
        this.lastNodeAdded = null;
        this.ad = new ActivityDiagram();
    }
    
    
    /** Generate an activity diagram from a use case */
    public ActivityDiagram generate (UseCaseXML uc) {
        
        // Iterator for main sequences
        Iterator ms;
        IStep mainS;
        Activity a;
        
        ms = uc.iteratorMainSequence ();
        while (ms.hasNext ()) {
            mainS = (IStep) ms.next ();
            
            a = this.createActivity (mainS);
            this.ad.addActivity (a);
            if (this.lastNodeAdded != null ) {
                this.ad.addTransition (this.lastNodeAdded, a);
            }
            this.lastNodeAdded = a;
        }
        
        this.ad.finalActivity (this.lastNodeAdded);
        
        
        return this.ad;
    }
    
    
    /** Helpper methods.
     * Builds an activity class from a node class **/
    private Activity createActivity(IStep step) {
        //log.fatal ("Method createActivity() not implemented yet.");
        Activity a = new Activity();
        a.setId (step.getId ());
        a.setDescription (step.getDescription () );
        return a;
    }

    //--- Log --------
    static Logger log;
    static {
        log = Logger.getLogger (ActivityDiagramGenerator.class.getName());
    }

    
}
