/*
 * GenerateTestObjectivesCommand.java
 *
 * Created on 23 de abril de 2006, 11:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.gui.commands;

import objectgen.activitymodel.*;
import objectgen.testobjective.*;
import objectgen.usecase.*;

import java.io.File;
import java.io.FileNotFoundException;



/**
 *
 * @author Rincew
 */
public class GenerateTestObjectivesCommand {
    
    /** Creates a new instance of GenerateTestObjectivesCommand */
    public GenerateTestObjectivesCommand () {
        
    }
        
        
    public String run (String file) {
        
        File f = new File(file);
        
        if (f.exists () == false) {
            return "File '" + file + "' does not exist.";
        }
        
        UseCaseXML uc = new UseCaseXML();
        try {
            uc.load (f);
        } catch (UseCaseXMLException ex) {
            return ex.toString ();
        }
        
        //System.out.println(uc);
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        //System.out.println(ad);
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        TestObjectiveList tol = tog.generate (ad);
        
        /*System.out.println("Objectives:");
        System.out.println(tol);
        
        System.out.println ("Ok.");*/
        return "Test Objectives: \n" + 
               "---------------------------------\n" + 
               tol.toString ();

    }
    
}
