/*
 * Path.java
 *
 * Created on 13 de abril de 2006, 21:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.activitymodel.*;
import org.apache.log4j.Logger;
import org.apache.log4j.Level;

/**
 * This class store a path through an activity graph, like 
 * other activity graph
 *
 * @author Rincew
 */
public class Path 
    implements Cloneable
{
    
    //--- Attributes ----------------
    
    /** Startg activity **/
    protected Activity startActivity;
    /** Last activity added to the path **/
    protected Activity lastActivity;
    
    /** Creates a new instance of Path */
    public Path () {
        this.startActivity = null;
    }
    
    /** Add a new activity to the path **/
    public void addActivity(Activity a) {
        Decision d;
        Activity aCopy = (Activity) a.clone ();
        aCopy.setNext (null);
        
        
        if (this.startActivity == null) {
            log.debug ("Adding first activity: "+aCopy.getId ());
            this.startActivity = aCopy;
            this.lastActivity = this.startActivity;
            return;
        }
        
        if (!this.lastActivity.isDesicion ()) {
            log.debug ("Adding from: "+this.lastActivity.getId ()+ " to "+aCopy.getId ());
            this.lastActivity.setNext (aCopy);
        } else {
            d = (Decision) this.lastActivity;
            log.debug ("Adding alternative from: "+this.lastActivity.getId ()+ " to "+aCopy.getId ());
            d.getFirstAlternative ().setNext (aCopy);
        }
        
        this.lastActivity = aCopy;
    }
    
    /** **/
    public void addAlternative(Alternative a) {
        Decision d = new Decision();
        d.setId ("D");
        d.setAlternative (a);
        if (this.startActivity == null) {
            log.warn ("First activity is a decision.");
            this.startActivity = d;
            this.lastActivity = this.startActivity;
        } else {
            log.debug ("addAlternative(...) - Adding desicion: "+d);
            // No apuntan al mismo objeto
            log.debug ("addAlternative(...) - next start before: "+this.startActivity.getNext ());
            log.debug ("addAlternative(...) - next before: "+this.lastActivity.getNext ());
            
            // Esto no debera ser as
            if (this.startActivity.getNext ()== null) {
                this.startActivity.setNext (d);
            } else {
                this.lastActivity.setNext (d);
            }
            
            log.debug ("addAlternative(...) - next after: "+this.lastActivity.getNext ());
            log.debug ("addAlternative(...) - next start after: "+this.startActivity.getNext ());
            this.lastActivity = d;
            // Aqu el camino no ha cambiado
            log.debug ("addAlternative(...) - New path: "+this.toString ());
        }
    }
    
    
    /** **/
    public String toString() {
        String s = "";
        Activity a;
        Decision d;
        a = this.startActivity;
        
        if (a == null) {
            //log.error ("Error. Comienzo nulo.");
            return "";
        }
        
        while( (a != null) && 
               (a.isFinal () == false)   ) 
        {
            s += a;
            s += "; ";
            if ( a.isDesicion () ) {
                d = (Decision) a;
                a = d.getFirstAlternative ().getNext ();
            } else {
                a = a.getNext ();
            }
        }
        //s += "\n";
        return s;
    }
    
    /** **/
    public Object clone() {
        Path p;
        try {
            p = (Path) super.clone();
            p.startActivity = (Activity) this.startActivity.clone ();
            p.lastActivity = (Activity) this.lastActivity.clone ();
            return p;
        } catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
        }
        log.fatal ("Clone returning null");
        return null;
    }

    //--- Log ----------------------
    static Logger log;
    static {
        log = Logger.getLogger (TestObjectiveGenerator.class.getName());
        log.setLevel (Level.INFO);
    }
}
