/*
 * TestObjectiveGenerator.java
 *
 * Created on 13 de abril de 2006, 21:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.activitymodel.*;
import org.apache.log4j.*;

/**
 *
 * @author Rincew
 */
public class TestObjectiveGenerator {


    TestObjectiveList objectives;
    
    /** Creates a new instance of TestObjectiveGenerator */
    public TestObjectiveGenerator () {
        //this.startActivity = a;
        //p = new Path();
    }
    
    /** This method should be private. 
     **/
    public TestObjectiveList generate(Activity a) {
        Path p = new Path();
        this.objectives = new TestObjectiveList();
        this.traverse(a, p);
        return this.objectives;
        
    }
    
    /** Generates a set of test objectives from a 
     * activity diagram. 
     **/
    public TestObjectiveList generate(ActivityDiagram ad) {
        this.objectives = new TestObjectiveList();
        this.generate (ad.getFirstActivity ());
        return this.objectives;
    }

    
    /** **/
    void traverse(Activity a, Path p) {
        
        log.debug ("Traversing: "+a.getId () + " with path: "+p);
        
        if (a.isFinal ()) {
            p.addActivity (a);
            log.debug("Path found: >>"+p+"<<");
            this.objectives.add (p);
            return;
        }
        
        if (a.isDesicion () == false) {
            p.addActivity (a);
            this.traverse (a.getNext (), /*(Path)p.clone ()*/p);
            return;
        }
        
        if (a.isDesicion ()) {
            this.traverseDesicion(a, /*(Path)p.clone ()*/p);
            return;
        }
    }

    /** **/
    void traverseDesicion(Activity a, Path p) {
        
        log.debug ("traverseDesicion(...) - Traversing desicion: "+a.getId () + " with path: "+p);
        
        Decision d = (Decision) a;
        Alternative al;
        java.util.Iterator it;
        Path newPath;
        
        it = d.iterator ();
        
        while (it.hasNext ()) {
            newPath = (Path)p.clone ();
            al = (Alternative) it.next ();
            log.debug ("traverseDesicion(...) - forking path: " + newPath + 
                       " with alternative "+al );
            newPath.addAlternative (al);
            this.traverse (al.getNext (), newPath);
        }
    }

    
    //--- Log --------
    static Logger log;
    static {
        log = Logger.getLogger (TestObjectiveGenerator.class.getName());
    }
}
